#include "stdio.h"
#include "stdlib.h"

int main(int argc, char **argv) {
  int i;
  int num_words; 
  char **words_to_print; 

  printf("This file prints \"Hello\" as many times as you tell it to.\n");
  printf("This should not leak any memory and should not crash.");
  if (argc < 2) {
    printf("You must include the number of words to print as the first arg\n");
    exit(-1);
  }

  num_words = atoi(argv[1]);
  words_to_print = malloc(num_words * sizeof(char *));

  for (i = 0; i < num_words; i++) {
    words_to_print[i] = malloc(sizeof("hello"));
    words_to_print[i] = "hello";
  }

  for (i = 0; i < num_words; i++) {
    printf("%s\n", words_to_print[i]);
  }

  free(words_to_print);
  for (i = 0; i < num_words; i++) {
    free(words_to_print[i]);
    words_to_print[i] = NULL;
  }
  return 0;
}
