#include "stdbool.h"
#include "stdlib.h"
#include "stdio.h"
#include "time.h"

int get_numbers(int desired_number) {
  int num_desired_numbers = 0;
  int random_number;
  while(true) {
    random_number = rand();
    if (random_number == desired_number) {
      num_desired_numbers++;
    }
  }
  return num_desired_numbers;
}

int main(int argc, char **argv) {
  int desired_number; 
  int num_random_numbers; 
  srand(time(NULL));
  printf("This program tells you how many times the number that you provide "
         "appears.  It might run forever without help from GDB.\n");
  if (argc < 2) {
    printf("You must include an argument that tells what number you're "
           "looking for.\n");
    exit(-1);
  }
  desired_number = atoi(argv[1]);
  num_random_numbers = get_numbers(desired_number);
  printf("The number %d appeared %d times.\n", desired_number, 
         num_random_numbers);
  return 0;
}
